Loading...
Searching...
No Matches
syrk: Symmetric rank k update
Batched LA » MAGMA BLAS and Auxiliary » Level 3: matrix-matrix operations, O(n^3) work

\(C = \alpha A A^T + \beta C\) where \(C\) is symmetric More...

## Functions

void | magmablas_csyrk_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaFloatComplex alpha, magmaFloatComplex const *const *dA_array, magma_int_t ldda, magmaFloatComplex beta, magmaFloatComplex **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| CHERK performs one of the Hermitian rank k operations.
void | magmablas_csyrk_vbatched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t *n, magma_int_t *k, magmaFloatComplex alpha, magmaFloatComplex const *const *dA_array, magma_int_t *ldda, magmaFloatComplex beta, magmaFloatComplex **dC_array, magma_int_t *lddc, magma_int_t batchCount, magma_queue_t queue)
| CSYRK performs one of the symmetric rank k operations.
void | magmablas_dsyrk_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, double alpha, double const *const *dA_array, magma_int_t ldda, double beta, double **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| DSYRK performs one of the symmetric rank k operations.
void | magmablas_ssyrk_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, float alpha, float const *const *dA_array, magma_int_t ldda, float beta, float **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| SSYRK performs one of the symmetric rank k operations.
void | magmablas_zsyrk_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaDoubleComplex alpha, magmaDoubleComplex const *const *dA_array, magma_int_t ldda, magmaDoubleComplex beta, magmaDoubleComplex **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| ZSYRK performs one of the symmetric rank k operations.
void | magmablas_zsyrk_vbatched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t *n, magma_int_t *k, magmaDoubleComplex alpha, magmaDoubleComplex const *const *dA_array, magma_int_t *ldda, magmaDoubleComplex beta, magmaDoubleComplex **dC_array, magma_int_t *lddc, magma_int_t batchCount, magma_queue_t queue)
| ZSYRK performs one of the symmetric rank k operations.

## Detailed Description

\(C = \alpha A A^T + \beta C\) where \(C\) is symmetric

## Function Documentation

## magmablas_csyrk_batched()

void magmablas_csyrk_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex | alpha,
|  | magmaFloatComplex const *const * | dA_array,
|  | magma_int_t | ldda,
|  | magmaFloatComplex | beta,
|  | magmaFloatComplex ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

CHERK performs one of the Hermitian rank k operations.

C := alpha*A*A**H + beta*C,

or

C := alpha*A**H*A + beta*C,

where alpha and beta are real scalars, C is an n by n Hermitian matrix and A is an n by k matrix in the first case and a k by n matrix in the second case.

## Parameters

Parameters

  [in] | uplo | magma_uplo_t. On entry, uplo specifies whether the upper or lower triangular part of the array C is to be referenced as follows:

uplo = MagmaUpper Only the upper triangular part of C is to be referenced.

uplo = MagmaLower Only the lower triangular part of C is to be referenced.

Parameters

  [in] | trans | magma_trans_t. On entry, trans specifies the operation to be performed as follows:

trans = MagmaNoTrans, C := alpha*A*A**H + beta*C.

trans = MagmaConjTrans, C := alpha*A**H*A + beta*C.

Parameters

  [in] | n | INTEGER. On entry, specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with trans = MagmaNoTrans, k specifies the number of columns of the matrix A, and on entry with trans = MagmaConjTrans, k specifies the number of rows of the matrix A. K must be at least zero.
  [in] | alpha | REAL On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a COMPLEX array A of DIMENSION ( ldda, ka ), where ka is k when trans = MagmaNoTrans, and is n otherwise. Before entry with trans = MagmaNoTrans, the leading m by k part of the array A must contain the matrix A, otherwise the leading k by m part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of each array A as declared in the calling (sub) program. When trans = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | beta | REAL. On entry, BETA specifies the scalar beta. When BETA is supplied as zero then C need not be set on input.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is a COMPLEX array C of DIMENSION ( lddc, n ). Before entry with uplo = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the Hermitian matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with uplo = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the Hermitian matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, m ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_csyrk_vbatched()

void magmablas_csyrk_vbatched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t * | n,
|  | magma_int_t * | k,
|  | magmaFloatComplex | alpha,
|  | magmaFloatComplex const *const * | dA_array,
|  | magma_int_t * | ldda,
|  | magmaFloatComplex | beta,
|  | magmaFloatComplex ** | dC_array,
|  | magma_int_t * | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

CSYRK performs one of the symmetric rank k operations.

    C := alpha*A*A**T + beta*C,

or

    C := alpha*A**T*A + beta*C,

where alpha and beta are scalars, C is an n by n symmetric matrix and A is an n by k matrix in the first case and a k by n matrix in the second case.

## Parameters

Parameters

  [in] | uplo | magma_uplo_t. On entry, uplo specifies whether the upper or lower triangular part of the array C is to be referenced as follows:

uplo = MagmaUpper Only the upper triangular part of C is to be referenced.

uplo = MagmaLower Only the lower triangular part of C is to be referenced.

Parameters

  [in] | trans | magma_trans_t. On entry, trans specifies the operation to be performed as follows:

trans = MagmaNoTrans C := alpha*A*A**T + beta*C.

trans = MagmaConjTrans C := alpha*A**T*A + beta*C.

Parameters

  [in] | n | Array of integers, size (batchCount + 1). On entry, each INTEGER N specifies the order of the corresponding matrix C. N must be at least zero. The last element of the array is used internally by the routine.
  [in] | k | Array of integers, size (batchCount + 1). On entry with trans = MagmaNoTrans, each INTEGER K specifies the number of columns of the corresponding matrix A, and on entry with trans = MagmaConjTrans, K specifies the number of rows of the corresponding matrix A. K must be at least zero. The last element of the array is used internally by the routine.
  [in] | alpha | COMPLEX. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, size (batchCount). Each is a COMPLEX array of DIMENSION ( LDDA, Ka ), where Ka is K when trans = MagmaNoTrans, and is N otherwise. Before entry with trans = MagmaNoTrans, the leading N by K part of the corresponding array A must contain the matrix A, otherwise the leading K by N part of the corresponding array must contain the matrix A.
  [in] | ldda | Array of integers, size (batchCount + 1). On entry, each INTEGER LDDA specifies the first dimension of the corresponding matrix A as declared in the calling (sub) program. When trans = MagmaNoTrans then LDDA must be at least max( 1, N ), otherwise ldda must be at least max( 1, K ). The last element of the array is used internally by the routine.
  [in] | beta | COMPLEX. On entry, BETA specifies the scalar beta. When BETA is supplied as zero then dC need not be set on input.

  [in,out]

  dC_array

  Array of pointers, size (batchCount). Each is a COMPLEX array of DIMENSION ( LDDC, N ). Before entry with uplo = MagmaUpper, the leading N by N upper triangular part of the corresponding array C must contain the upper triangular part of the corresponding symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with uplo = MagmaLower, the leading N by N lower triangular part of the corresponding array C must contain the lower triangular part of the corresponding symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | Array of integers, size (batchCount + 1). On entry, each INTEGER LDDC specifies the first dimension of the corresponding matrix C as declared in the calling (sub) program. LDDC must be at least max( 1, M ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_dsyrk_batched()

void magmablas_dsyrk_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | double | alpha,
|  | double const *const * | dA_array,
|  | magma_int_t | ldda,
|  | double | beta,
|  | double ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

DSYRK performs one of the symmetric rank k operations.

C := alpha*A*A**H + beta*C,

or

C := alpha*A**H*A + beta*C,

where alpha and beta are real scalars, C is an n by n symmetric matrix and A is an n by k matrix in the first case and a k by n matrix in the second case.

## Parameters

Parameters

  [in] | uplo | magma_uplo_t. On entry, uplo specifies whether the upper or lower triangular part of the array C is to be referenced as follows:

uplo = MagmaUpper Only the upper triangular part of C is to be referenced.

uplo = MagmaLower Only the lower triangular part of C is to be referenced.

Parameters

  [in] | trans | magma_trans_t. On entry, trans specifies the operation to be performed as follows:

trans = MagmaNoTrans C := alpha*A*A**H + beta*C.

trans = MagmaTrans C := alpha*A**H*A + beta*C.

Parameters

  [in] | n | INTEGER. On entry, specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with trans = MagmaNoTrans, k specifies the number of columns of the matrix A, and on entry with trans = MagmaTrans, k specifies the number of rows of the matrix A. K must be at least zero.
  [in] | alpha | DOUBLE PRECISION On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a DOUBLE PRECISION array A of DIMENSION ( ldda, ka ), where ka is k when trans = MagmaNoTrans, and is n otherwise. Before entry with trans = MagmaNoTrans, the leading m by k part of the array A must contain the matrix A, otherwise the leading k by m part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of each array A as declared in the calling (sub) program. When trans = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta. When BETA is supplied as zero then C need not be set on input.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is a DOUBLE PRECISION array C of DIMENSION ( lddc, n ). Before entry with uplo = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with uplo = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, m ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_ssyrk_batched()

void magmablas_ssyrk_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | float | alpha,
|  | float const *const * | dA_array,
|  | magma_int_t | ldda,
|  | float | beta,
|  | float ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

SSYRK performs one of the symmetric rank k operations.

C := alpha*A*A**H + beta*C,

or

C := alpha*A**H*A + beta*C,

where alpha and beta are real scalars, C is an n by n symmetric matrix and A is an n by k matrix in the first case and a k by n matrix in the second case.

## Parameters

Parameters

  [in] | uplo | magma_uplo_t. On entry, uplo specifies whether the upper or lower triangular part of the array C is to be referenced as follows:

uplo = MagmaUpper Only the upper triangular part of C is to be referenced.

uplo = MagmaLower Only the lower triangular part of C is to be referenced.

Parameters

  [in] | trans | magma_trans_t. On entry, trans specifies the operation to be performed as follows:

trans = MagmaNoTrans C := alpha*A*A**H + beta*C.

trans = MagmaTrans C := alpha*A**H*A + beta*C.

Parameters

  [in] | n | INTEGER. On entry, specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with trans = MagmaNoTrans, k specifies the number of columns of the matrix A, and on entry with trans = MagmaTrans, k specifies the number of rows of the matrix A. K must be at least zero.
  [in] | alpha | REAL On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a REAL array A of DIMENSION ( ldda, ka ), where ka is k when trans = MagmaNoTrans, and is n otherwise. Before entry with trans = MagmaNoTrans, the leading m by k part of the array A must contain the matrix A, otherwise the leading k by m part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of each array A as declared in the calling (sub) program. When trans = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | beta | REAL. On entry, BETA specifies the scalar beta. When BETA is supplied as zero then C need not be set on input.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is a REAL array C of DIMENSION ( lddc, n ). Before entry with uplo = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with uplo = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, m ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_zsyrk_batched()

void magmablas_zsyrk_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex | alpha,
|  | magmaDoubleComplex const *const * | dA_array,
|  | magma_int_t | ldda,
|  | magmaDoubleComplex | beta,
|  | magmaDoubleComplex ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

ZSYRK performs one of the symmetric rank k operations.

C := alpha*A*A**T + beta*C,

or

C := alpha*A**T*A + beta*C,

where alpha and beta are real scalars, C is an n by n symmetric matrix and A is an n by k matrix in the first case and a k by n matrix in the second case.

## Parameters

Parameters

  [in] | uplo | magma_uplo_t. On entry, uplo specifies whether the upper or lower triangular part of the array C is to be referenced as follows:

uplo = MagmaUpper Only the upper triangular part of C is to be referenced.

uplo = MagmaLower Only the lower triangular part of C is to be referenced.

Parameters

  [in] | trans | magma_trans_t. On entry, trans specifies the operation to be performed as follows:

trans = MagmaNoTrans C := alpha*A*A**T + beta*C.

trans = MagmaTrans C := alpha*A**T*A + beta*C.

Parameters

  [in] | n | INTEGER. On entry, specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with trans = MagmaNoTrans, k specifies the number of columns of the matrix A, and on entry with trans = MagmaConjTrans, k specifies the number of rows of the matrix A. K must be at least zero.
  [in] | alpha | DOUBLE PRECISION On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a COMPLEX_16 A array of DIMENSION ( ldda, ka ), where ka is k when trans = MagmaNoTrans, and is n otherwise. Before entry with trans = MagmaNoTrans, the leading m by k part of the array A must contain the matrix A, otherwise the leading k by m part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of each array A as declared in the calling (sub) program. When trans = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta. When BETA is supplied as zero then C need not be set on input.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is a COMPLEX_16 array C of DIMENSION ( lddc, n ). Before entry with uplo = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with uplo = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, m ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_zsyrk_vbatched()

void magmablas_zsyrk_vbatched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t * | n,
|  | magma_int_t * | k,
|  | magmaDoubleComplex | alpha,
|  | magmaDoubleComplex const *const * | dA_array,
|  | magma_int_t * | ldda,
|  | magmaDoubleComplex | beta,
|  | magmaDoubleComplex ** | dC_array,
|  | magma_int_t * | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

ZSYRK performs one of the symmetric rank k operations.

    C := alpha*A*A**T + beta*C,

or

    C := alpha*A**T*A + beta*C,

where alpha and beta are scalars, C is an n by n symmetric matrix and A is an n by k matrix in the first case and a k by n matrix in the second case.

## Parameters

Parameters

  [in] | uplo | magma_uplo_t. On entry, uplo specifies whether the upper or lower triangular part of the array C is to be referenced as follows:

uplo = MagmaUpper Only the upper triangular part of C is to be referenced.

uplo = MagmaLower Only the lower triangular part of C is to be referenced.

Parameters

  [in] | trans | magma_trans_t. On entry, trans specifies the operation to be performed as follows:

trans = MagmaNoTrans C := alpha*A*A**T + beta*C.

trans = MagmaConjTrans C := alpha*A**T*A + beta*C.

Parameters

  [in] | n | Array of integers, size (batchCount + 1). On entry, each INTEGER N specifies the order of the corresponding matrix C. N must be at least zero. The last element of the array is used internally by the routine.
  [in] | k | Array of integers, size (batchCount + 1). On entry with trans = MagmaNoTrans, each INTEGER K specifies the number of columns of the corresponding matrix A, and on entry with trans = MagmaConjTrans, K specifies the number of rows of the corresponding matrix A. K must be at least zero. The last element of the array is used internally by the routine.
  [in] | alpha | COMPLEX_16. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, size (batchCount). Each is a COMPLEX_16 array of DIMENSION ( LDDA, Ka ), where Ka is K when trans = MagmaNoTrans, and is N otherwise. Before entry with trans = MagmaNoTrans, the leading N by K part of the corresponding array A must contain the matrix A, otherwise the leading K by N part of the corresponding array must contain the matrix A.
  [in] | ldda | Array of integers, size (batchCount + 1). On entry, each INTEGER LDDA specifies the first dimension of the corresponding matrix A as declared in the calling (sub) program. When trans = MagmaNoTrans then LDDA must be at least max( 1, N ), otherwise ldda must be at least max( 1, K ). The last element of the array is used internally by the routine.
  [in] | beta | COMPLEX_16. On entry, BETA specifies the scalar beta. When BETA is supplied as zero then dC need not be set on input.

  [in,out]

  dC_array

  Array of pointers, size (batchCount). Each is a COMPLEX_16 array of DIMENSION ( LDDC, N ). Before entry with uplo = MagmaUpper, the leading N by N upper triangular part of the corresponding array C must contain the upper triangular part of the corresponding symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with uplo = MagmaLower, the leading N by N lower triangular part of the corresponding array C must contain the lower triangular part of the corresponding symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | Array of integers, size (batchCount + 1). On entry, each INTEGER LDDC specifies the first dimension of the corresponding matrix C as declared in the calling (sub) program. LDDC must be at least max( 1, M ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.